%set_verify_elf_method unresolved=relaxed
Name: serioussamclassic-xplus
Summary: Serious Sam Classic native Linux modification
License: GPL2
Version: 1.10.5
Release: alt1

Group: Games/Arcade
Url: https://github.com/tx00100xt/SeriousSamClassic
Source: %name-%version.tar.gz

BuildRequires: cmake libstdc++-devel-static rpm-macros-cmake sed flex bison
BuildRequires: zlib-devel libogg-devel libvorbis-devel glibc-devel
BuildRequires: gcc-c++ python3-dev libSDL2-devel ImageMagick-tools
Requires: glibc libstdc++ zlib libogg libvorbis libSDL2 awk sed
Requires(pre): /usr/bin/serioussam  /usr/bin/serioussamse
ExclusiveArch: %ix86 %{arm} x86_64 aarch64 e2k

%description 
Open source nodifications based on game engine version developed by Croteam for Serious Sam Classic (Windows, Linux, FreeBSD, Raspberry Pi OS)
Playing Serious Sam: The First and Second Encounter still requires a legitimate copy of
the game. You can purchase a copy from Steam or your favorite retailer.

Place .gro game files and Levels, Help folders from the Serious Sam installation to:
$HOME/.local/share/Serious-Engine/serioussam   - for Serious Sam: The First Encounter
$HOME/.local/share/Serious-Engine/serioussamse - for Serious Sam: The Second Encounter

Place Mods game files to:
$HOME/.local/share/Serious-Engine/serioussam/Mods   - for Serious Sam: The First Encounter
$HOME/.local/share/Serious-Engine/serioussamse/Mods - for Serious Sam: The Second Encounter

%prep

%setup

%build

# standart x86_64 build
%ifarch x86_64
echo "ALT Linux arch x86_64"
CMAKE_ARGS="-DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX:PATH=/usr"
echo "CMAKE_ARGS $CMAKE_ARGS"
%endif

# standart i586 build
%ifarch %ix86
echo "ALT Linux arch i686"
CMAKE_ARGS="-DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX:PATH=/usr -DCMAKE_C_FLAGS=-mmmx -DCMAKE_CXX_FLAGS=-mmmx -DUSE_I386_NASM_ASM=TRUE"
echo "CMAKE_ARGS $CMAKE_ARGS"
%endif

# for raspberry pi 3b/4
%ifarch aarch64
MODEL_PI=$(cat /proc/cpuinfo | grep Model)
if [[ $MODEL_PI = *"Raspberry Pi 4"* ]]; then echo $MODEL_PI;
CMAKE_ARGS="-DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX:PATH=/usr -DUSE_I386_NASM_ASM=FALSE -DRPI4=TRUE"
echo "CMAKE_ARGS $CMAKE_ARGS"
echo "Build for model Raspberry Pi4"
else
echo "CMAKE_ARGS $CMAKE_ARGS"
CMAKE_ARGS="-DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX:PATH=/usr -DUSE_I386_NASM_ASM=FALSE"
echo "Stadart aarch64 build"
fi
%endif

# e2k
%ifarch e2k
echo "ALT Linux arch e2k"
CMAKE_ARGS="-DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX:PATH=/usr"
echo "CMAKE_ARGS $CMAKE_ARGS"
%endif

NCPU=`cat /proc/cpuinfo |grep vendor_id |wc -l`

if [[ $NCPU -eq 0 ]]
then
  let NCPU='4'
else
  let NCPU=$NCPU
fi
echo "Cores: $NCPU"

find . -name "CMakeLists.txt" -exec sed -i 's/-march=native/-mtune=generic/g' {} +
rm -rf ./%_arch-alt1-linux
mkdir ./%_arch-alt1-linux
cd $_
cmake .. $CMAKE_ARGS -DXPLUS=TRUE
make -j$NCPU

%install
mkdir -p %buildroot%_libdir/{serioussam,serioussam/Mods,serioussam/Mods/XPLUS}
mkdir -p %buildroot%_libdir/{serioussamse,serioussamse/Mods,serioussamse/Mods/XPLUS}

install -D -m0755 ./%_arch-alt1-linux/SamTFE/Sources/Debug/libGame.so %buildroot%_libdir/serioussam/Mods/XPLUS
install -D -m0755 ./%_arch-alt1-linux/SamTFE/Sources/Debug/libEntities.so %buildroot%_libdir/serioussam/Mods/XPLUS

install -D -m0755 ./%_arch-alt1-linux/SamTSE/Sources/Debug/libGameMP.so %buildroot%_libdir/serioussamse/Mods/XPLUS
install -D -m0755 ./%_arch-alt1-linux/SamTSE/Sources/Debug/libEntitiesMP.so %buildroot%_libdir/serioussamse/Mods/XPLUS

%files

%_libdir/serioussam/Mods/XPLUS/libGame.so
%_libdir/serioussam/Mods/XPLUS/libEntities.so
%_libdir/serioussamse/Mods/XPLUS/libGameMP.so
%_libdir/serioussamse/Mods/XPLUS/libEntitiesMP.so

%post

%postun

%changelog
* Mon Apr 24 2023 tx00100xt initial SPEC file.
- 

